#!/bin/bash

# Para lanzar el script con la copia al servicio FTP añadir el parametro "-ftp"

LOG_FILE=$HOME/backup_db.log
DATE=$(date)
DATABASE_NAME=davinci
BACKUP_LOCAL_DIR=$HOME/BACKUPS
BACKUP_FILE=`date --iso -d 'now'`_$DATABASE_NAME.sql.gz
DAYS_BACKUP=10
FTP_HOST=
FTP_USER=
FTP_PASS=
FTP_PORT=
FTP_PATH=

exec 1>> $LOG_FILE 2>&1

echo "---------- Iniciando Script... ----------"

function transferencia_ftp {
  if [ -e $BACKUP_FILE ]; then
    echo "$DATE Iniciando FTP"
    lftp -c "debug 2; open -u $FTP_USER,$FTP_PASS ftp://$FTP_HOST -p $FTP_PORT; glob -a rm -r $FTP_PATH/*.gz; put -O $FTP_PATH $BACKUP_FILE; exit; "
    echo "$DATE Transferencia $BACKUP_FILE completada"
    else
      echo "$DATE Error al Respaldar $DATABASE_NAME por FTP"
   fi
}

if [ -d $BACKUP_LOCAL_DIR ]; then
  cd $BACKUP_LOCAL_DIR
  else
    mkdir $BACKUP_LOCAL_DIR
    cd $BACKUP_LOCAL_DIR
    echo "$DATE Directorio $BACKUP_LOCAL_DIR creado"
fi

if [ -d $BACKUP_LOCAL_DIR ]; then
  echo "$DATE Respaldando y comprimiendo la base de datos $DATABASE_NAME..."
  sudo -u postgres pg_dump $DATABASE_NAME | gzip > $BACKUP_FILE
  echo "$DATE Archivo $BACKUP_FILE creado"
  
  if [[ -z "$1" ]]; then
    echo "$DATE Solo copia local"
    elif [ "$1" = "-ftp" ]; then
      transferencia_ftp
    else 
      echo "$DATE $1 parámetro incorrecto"
  fi
    echo "$DATE Backups antiguos a eliminar"
    # Lista en log los archivos a eliminar
    find . -name "*.sql.gz" -type f -mtime +$DAYS_BACKUP
    find . -name "*.sql.gz" -type f -mtime +$DAYS_BACKUP -delete
    echo "$DATE Completado"
  else
    echo "$DATE Error al crear directorio"
    exit 0
fi
exit 0
